#include <avsys.h>

static char posbuf[64];


void write_middle(const char *msg, int y)
{
    int slen;

    ClearLCDArea(0, y, LCD_WIDTH, y+10, 0);
    slen=GetStringLength(msg,PRPFONT11B);
    WriteString((LCD_WIDTH-slen)/2,y,msg,DRAW_BLACK);
}

void delay_sec() {
    int i;
    for (i=0; i<100; i++)
        Delay_10ms();
}

int main()
{
	int key, last;
	unsigned char penx,peny;

	ClearLCD(0);
	SetFontType(PRPFONT11B);

        write_middle("Gimme some input!", 100);
        write_middle("hit address to quit", LCD_HIGH - 15);

	while(1) {
            if (!(key=GetKey(&penx,&peny))) {
                if (last == PENDOWN) {
                    /* PENUP */
                    write_middle("You released the pen", 100);
                }
                last = key;
                continue;
            }
            if (key != PENDOWN || last != PENDOWN)
                PenBeep();

            switch (key)
            {
            case ADDRESS:
                write_middle("You pressed ADDRESS", 100); 
                delay_sec();
                return APPLICATION;
                break;
            case PGDN:
                write_middle("You pressed PGDN", 100); break;
            case PGUP:
                write_middle("You pressed PGUP", 100); break;
            case SCHEDULE:
                write_middle("You pressed SCHEDULE", 100); break;
            case TASK:
                write_middle("You pressed TASK", 100); break;
            case MEMO:
                write_middle("You pressed MEMO", 100); break;
            case CALENDAR:
                write_middle("You pressed CALENDAR", 100); break;
            case EXPENSES:
                write_middle("You pressed EXPENSES", 100); break;
            case CALCULATOR:
                write_middle("You pressed CALCULATOR", 100); break;
            case TABLE:
                write_middle("You pressed TABLE", 100); break;
            case APPLICATION:
                write_middle("You pressed APPLICATION", 100); break;
            case FIND:
                write_middle("You pressed FIND", 100); break;
/*
            case POWER:
                write_middle("You pressed POWER", 100); break;
            case BACK_LIGHT:
                write_middle("You pressed BACK_LIGHT", 100); break;
            case PC_LINK_KEY:
                write_middle("You pressed PC_LINK_KEY", 100); break;
*/
            case PENDOWN:
            {
                if (penx >= 0 && penx < LCD_WIDTH && 
                    peny >= 0 && peny < LCD_HIGH) {
                    write_middle("You tapped the pen", 100);
                    strncpy(posbuf, "X: ", 3);
                    itoa(penx, posbuf+3, 10);
                    write_middle(posbuf, 112);
                    strncpy(posbuf, "Y: ", 3);
                    itoa(peny, posbuf+3, 10);
                    write_middle(posbuf, 123);
                }
                else {
                    write_middle("You tapped off the screen?", 100);
                    delay_sec();
                    return APPLICATION;
                }
            }
            break;

            default:
                write_middle("You did somethin else!", 100);
                delay_sec();
                return key;                
                break;
            }
            last = key;
        }

	return key;
}





